"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _antd = require("antd");

var _jsBase = require("js-base64");

var _jsCookie = _interopRequireDefault(require("js-cookie"));

var _login = _interopRequireDefault(require("../pages/user/login/login"));

var _city = _interopRequireDefault(require("./city.json"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var ERR_OK = '0000';

var Site =
/*#__PURE__*/
function () {
  function Site(props) {
    _classCallCheck(this, Site);

    this.weatherCity = null;
    this.globalConfig = props.global;
    this.updateConfig = props.updateConfig;
    this.props = props;
    this.init();
  }

  _createClass(Site, [{
    key: "init",
    value: function init(config) {// this.initWeatherCity();
    }
  }, {
    key: "initWeatherCity",
    value: function initWeatherCity() {
      var _this = this;

      try {
        if (navigator.onLine && this.globalConfig && this.globalConfig.userInfo && this.globalConfig.userInfo.site) {
          Http.getCity().then(function (res) {
            if (res && !isNaN(res.cid)) {
              var cityResult = JSON.parse(_city["default"]);
              var city = cityResult[res.cid];
              _this.weatherCity = city ? city : null;
            }
          });
        }
      } catch (e) {
        console.error(e);
      }
    }
  }, {
    key: "getCityStationsForUser",
    value: function getCityStationsForUser() {
      debugger;
      var loginName = this.globalConfig.userInfo.loginName;
      var self = this;
      return new Promise(function (resolve, reject) {
        Http.getAllGroupsInfoForUser({
          loginName: loginName,
          'request.preventCache': new Date().getTime()
        }, {
          ignoreSite: true
        }).then(function (res) {
          debugger;

          if (res && res.say.errMsg === '' && res.say.statusCode === ERR_OK) {
            var result = res.getMe;
            var city = self.weatherCity;
            var _arr = [];
            self.globalConfig.userInfo.groupType = "";
            self.globalConfig.userInfo.Groups = res.getMe;
            self.globalConfig.userInfo.Industries = new Array();

            if (self.globalConfig.userInfo.Groups && self.globalConfig.userInfo.Groups.length) {
              self.globalConfig.userInfo.Groups.forEach(function (group) {
                if (group.industry && self.globalConfig.userInfo.Industries.indexOf(group.industry) < 0) self.globalConfig.userInfo.Industries.push(group.industry);
              });
            }

            if (self.globalConfig.userInfo && self.globalConfig.userInfo.site && self.globalConfig.userInfo.Groups && self.globalConfig.userInfo.Groups.length) {
              var _indestryItem = self.globalConfig.userInfo.Groups.find(function (item) {
                return item.site == self.globalConfig.userInfo.site;
              });

              if (_indestryItem && _indestryItem.industry) {
                self.globalConfig.Industry = _indestryItem.industry;
              }
            }

            var allStation = [];
            var projectStation = [];
            self.showStations = [];

            if (self.globalConfig.Industry) {
              allStation = result.filter(function (item) {
                return item.industry == self.globalConfig.Industry;
              });
              self.showStations = allStation.filter(function (item) {
                return item.promoteIndex && item.promoteIndex > 0;
              });
              projectStation = allStation.filter(function (item) {
                return !item.promoteIndex;
              });
            } else {
              allStation = result;
            }

            if (allStation.length) {
              var allChoice = false;
              allStation.forEach(function (val) {
                if (val.promoteIndex == 0) {
                  allChoice = true;
                }
              });

              if (!allChoice) {// me.$el.find('#changeCityWays').hide();
                // me.$el.find('.LMBcityBox').hide();
                // me.$el.find('div.cities').css('min-width', 'initial');
                // me.$el.find('.focusStations').addClass('LMBcolumnList');
              }

              if (allStation.length > 120) {// $(me.el).find("div.cities div.cityContent").css("height", '335px');
              }

              var _enterprise = null;

              if (self.globalConfig.userInfo.site && self.globalConfig.userInfo.site.length) {
                _enterprise = allStation.filter(function (enterprise) {
                  return enterprise.site == self.globalConfig.userInfo.site;
                });
              }

              if (_enterprise && _enterprise.length) {
                if (_enterprise[0].groupName.indexOf("演示" >= 0)) {
                  _arr[0] = _enterprise[0].groupName;
                } else {
                  _arr = _enterprise[0].city.split('/');
                }

                var tmp = _enterprise[0].city.split('/')[1];

                city = tmp.substr(0, tmp.length - 1);
                self.globalConfig.userInfo.groupType = _enterprise[0].groupType;
              } else {
                _arr = allStation[0].city.split('/');
                var _tmp = _arr[1];
                city = _tmp.substr(0, _tmp.length - 1);
                self.globalConfig.userInfo.groupType = allStation[0].groupType;
              }
            }

            if (allStation.length > 1) {
              self.currentStationName = _arr[_arr.length - 1];
              self.AvailableofRegionName(projectStation);
              self.buildCitySelectTemple(projectStation);
            } //只有演示环境出现友好提示


            if (allStation.length === self.showStations.length) {
              self.isOnlyDisplay = true;
            } else {
              self.AvailableofRegionName(projectStation);
              self.buildCitySelectTemple(projectStation);
            }

            self.updateConfig && self.updateConfig(self.globalConfig);
            var stations = self.insertYSStation();

            if (city) {
              Http.getWeather({
                city: city,
                'request.preventCache': new Date().getTime()
              }, {
                ignoreSite: true
              }).then(function (res) {
                if (res.say.statusCode === ERR_OK) {
                  var firtValue = res.getMe[0];
                  console.log("firtValue", firtValue);

                  if (firtValue.cityName) {
                    var text = firtValue.forcastFirst.split(' ')[1];
                    var imgPath = firtValue.presentPictureFirst.replace('gif', 'svg');
                    resolve({
                      stations: stations,
                      weathers: {
                        icon: "https://panda-water.cn/web4/assets/images/weather2/".concat(imgPath),
                        text: firtValue.temperatureFirst
                      },
                      currentStationName: self.currentStationName
                    });
                  }
                } else {
                  resolve({
                    stations: stations,
                    currentStationName: self.currentStationName,
                    weathers: {}
                  });
                }
              })["catch"](function (error) {
                resolve({
                  stations: stations,
                  currentStationName: self.currentStationName,
                  weathers: {}
                });
              });
            } else {
              resolve({
                stations: stations,
                currentStationName: self.currentStationName,
                weathers: {}
              });
            }
          }
        });
      });
    }
  }, {
    key: "insertYSStation",
    value: function insertYSStation() {
      var _this2 = this;

      var hot = ["HOT", "县", "市", "New"];
      this.showStations.sort(function (a, b) {
        return a.promoteIndex - b.promoteIndex;
      });
      return this.showStations.map(function (item, index) {
        var marginRight = 20;
        var style = {};

        switch (item.promoteTip) {
          case hot[3]:
          case hot[0]:
            marginRight = 40;
            break;

          case hot[1]:
          case hot[2]:
            marginRight = 30;
            break;

          default:
            marginRight = 20;
            break;
        }

        style.marginRight = marginRight;
        item.style = style;

        if (item.promoteTip && hot.includes(item.promoteTip)) {
          item.promoteTip = item.promoteTip;
        } else if (index === _this2.showStations.length) {
          item.style.marginRight = "-20px";
        }

        return item;
      });
    }
  }, {
    key: "getNumberofRegion",
    value: function getNumberofRegion() {}
  }, {
    key: "AvailableofRegionName",
    value: function AvailableofRegionName() {}
  }, {
    key: "writeCookie",
    value: function writeCookie(token, site) {
      var date = new Date();
      date.setTime(date.getTime() + 24 * 60 * 60 * 1000); // date = date.toGMTString();

      _jsCookie["default"].set("token", token, {
        expires: date,
        path: "/"
      });

      var encodeSite = (0, _jsBase.encode)(encodeURIComponent(site));

      _jsCookie["default"].set("site", encodeSite, {
        expires: date,
        path: "/"
      });

      var loginSite = this.getLocalSites();
      loginSite[token] = site;
      localStorage.setItem("loginSite", JSON.stringify(loginSite));
      var login = new _login["default"](this.props, function () {
        login.init();
        window.location.reload();
      });
    }
  }, {
    key: "changeGroup",
    value: function changeGroup(event) {
      var _this3 = this;

      event.persist();
      var site = event.target.dataset.site;
      var loginName = this.globalConfig.userInfo.loginName;
      Http.generateTokenQuick({
        loginName: loginName
      }, {
        ignoreSite: true
      }).then(function (res) {
        var token = res.token;

        if (token) {
          _this3.beforeChangeCheck(token, site);
        }
      })["catch"](function (error) {
        _antd.message.warning("切换企业失败");
      });
    }
  }, {
    key: "beforeChangeCheck",
    value: function beforeChangeCheck(token, site) {
      var _this4 = this;

      Http.getUserInfo({
        token: token,
        subOID: 'subOID',
        site: site
      }, {
        ignoreSite: true
      }).then(function (res) {
        if (res && !res.errMsg) {
          _this4.writeCookie(token, site);
        } else {
          _antd.message.warning('企业切换失败，请联系管理员排查问题！');
        }
      })["catch"](function (e) {
        console.log(e);

        _antd.message.warning('企业切换失败，请联系管理员排查问题！');
      });
    }
  }, {
    key: "pySegSort",
    value: function pySegSort(data) {
      if (!String.prototype.localeCompare) return null;
      var letters;
      var segs = []; // 存放数据

      var py = []; // 存放首字母

      var res = {};
      letters = "ABCDEFGHJKLMNOPQRSTWXYZ".split('');
      var ref = {
        "A": {
          pName: ['安徽省'],
          data: []
        },
        'B': {
          pName: ['北京市'],
          data: []
        },
        'C': {
          pName: ['重庆市'],
          data: []
        },
        "F": {
          pName: ['福建省'],
          data: []
        },
        "G": {
          pName: ["甘肃省", "广东省", "广西壮族自治区", "贵州省"],
          data: []
        },
        "H": {
          pName: ["海南省", "河北省", "河南省", "黑龙江省", "湖北省", "湖南省"],
          data: []
        },
        "J": {
          pName: ["吉林省", "江苏省", "江西省"],
          data: []
        },
        "L": {
          pName: ["辽宁省"],
          data: []
        },
        "N": {
          pName: ["内蒙古自治区", "宁夏回族自治区"],
          data: []
        },
        "Q": {
          pName: ["青海省"],
          data: []
        },
        "S": {
          pName: ["山东省", "山西省", "陕西省", "上海市", "四川省"],
          data: []
        },
        'T': {
          pName: ['天津市'],
          data: []
        },
        "X": {
          pName: ["新疆维吾尔自治区", "西藏藏族自治区"],
          data: []
        },
        "Y": {
          pName: ["云南省"],
          data: []
        },
        "Z": {
          pName: ["浙江省"],
          data: []
        }
      };
      arr.map(function (item) {
        var proviceName = item.proviceName;

        for (var key in ref) {
          if (ref[key].pName.includes(proviceName)) {
            ref[key].data.push(item);
            break;
          }
        }
      });
      letters.map(function (item) {
        if (ref[item] && ref[item].data.length) {
          py.push(item);
          segs.push({
            letter: item,
            data: ref[item].data
          });
        }
      });
      res["segs"] = segs;
      res["py"] = py;
      return res;
    }
  }, {
    key: "AvailableofRegionName",
    value: function AvailableofRegionName() {}
  }, {
    key: "buildCitySelectTemple",
    value: function buildCitySelectTemple(data) {
      var arr = [];
      var pNames = [];

      for (var i = 0; i < data.length; i++) {
        var pName = data[i].city.split('/')[0];

        if (pNames.indexOf(pName) < 0) {
          pNames.push(pName);
        }
      }

      pNames.forEach(function (item, index) {
        arr[arr.length] = {
          proviceName: item,
          stations: []
        };
      });

      for (var j = 0; j < data.length; j++) {
        var itemJ = data[j];
        var itemJ_pName = itemJ.city.split("/")[0];

        for (var k = 0; k < arr.length; k++) {
          var itemK = arr[k];

          if (itemJ_pName == itemK.proviceName) {
            arr[k].stations[itemK.stations.length] = {
              stationID: itemJ.groupID,
              site: itemJ.site,
              cityName: itemJ.city,
              groupName: itemJ.groupName,
              isDeployed: itemJ.isDeployed
            };
          }
        }
      }

      var cities = JSON.stringify(this.pySegSort(arr));
    }
  }, {
    key: "getLocalSites",
    value: function getLocalSites() {
      var localSite = localStorage.getItem("loginSite"),
          value = {};

      if (localSite) {
        value = JSON.parse(localSite);
      }

      return value;
    }
  }]);

  return Site;
}();

var _default = Site;
exports["default"] = _default;